<template>
	<div class="white-block">
    <div class="padding">
      <h3>Адрес регистрации</h3>
    </div>
    <hr/>
    <div class="padding">
      <div class="row">
        <div class="column">
          <label for="region">Район, населенный пункт, улица</label>
          <input type="text"
                 id="region"
                 ref="address"
                 name="regionRegistration"
                 v-model="region"
                 @input="getRegion"
                 @keyup.esc="checkStreet"
                 @blur="checkStreet"
                 :class="getValidateClass('regionRegistration')"
                 @keydown.down="moveDownRegion"
                 @keydown.up="moveUpRegion"
                 v-validate="'required|min:3|max:250'"
                 @keydown.enter.prevent="checkRegion(selectedItem); isOpenRegion = false"
                 autocomplete="off"
          >
          <ul class="options-list" v-show="isOpenRegion">
            <li v-for="(item, index) in suggestions"
                @mousedown="checkRegion(index)"
                @mouseenter="selectedItem = index"
                :class="{'highlighted': index === selectedItem}"
            >{{item.value}}</li>
          </ul>
          <validate-message
              v-show="vErrors.has('regionRegistration')"
            >{{ vErrors.first('regionRegistration') }}
            </validate-message>
        </div>
      </div>

      <div class="warning-yellow-block">
        <ul class="without-marker">
          <li><strong>1.</strong> Начните вводить адрес и выберите из списка.</li>
          <li><strong>2.</strong> В случае, если в вашем населенном пункте (деревне, селе) улица существует, но вы преднамеренно не указали её, по заявке будет отказ!</li>
        </ul>
      </div>

      <div class="row">
          <div class="columns two-third">
            <label for="house">Дом</label>
            <input type="text"
                   id="house"
                   name="houseRegistration"
                   v-model="house"
                   @input="getHouse"
                   :class="getValidateClass('houseRegistration')"
                   @keyup.esc="fixHouse"
                   @blur="fixHouse"
                   @keydown.down="moveDownHouse"
                   @keydown.up="moveUpHouse"
                   v-validate="'required'"
                   @keydown.enter.prevent="checkRegion(selectedItem); isOpenHouse = false"
                   autocomplete="off"

            >
            <ul class="options-list" v-show="isOpenHouse">
              <li v-for="(item, index) in houses"
                  @mousedown="checkHouse(index)"
                  @mouseenter="selectedItem = index"
                  :class="{'highlighted': index === selectedItem}"
              >{{item}}</li>
            </ul>
            <validate-message
              v-show="vErrors.has('houseRegistration')"
            >{{ vErrors.first('houseRegistration') }}
            </validate-message>
          </div>

          <div class="columns two-third">
            <label for="index">Индекс</label>
            <input type="text"
                   id="index"
                   name="индекс"
                   :class="getValidateClass('индекс')"
                   @input="changeIndex"
                   v-model="index"
                   v-mask="'######'"
                   v-validate="'required|addressIndex'"
                   autocomplete="off"

            >

            <validate-message
              v-show="vErrors.has('индекс')"
            >{{ vErrors.first('индекс') }}
            </validate-message>
          </div>

          <div class="columns two-third">
            <label for="housing">Корпус</label>
            <input type="text"
                   id="housing"
                   name="housing"
                   v-model="housing"
                   @input="changeHousing"
                   autocomplete="off"

            >
          </div>

          <div class="columns two-third">
            <label for="building">Строение</label>
            <input type="text"
                   id="building"
                   name="building"
                   v-model="building"
                   @input="changeBuilding"
                   autocomplete="off"

            >
          </div>

          <div class="columns two-third">
            <label for="flat">Квартира</label>
            <input type="text"
                   id="flat"
                   name="flat"
                   v-mask="'###'"
                   v-model="user.address.flat"
                   @input="changeFlat"
                   autocomplete="off"

            >
          </div>
      </div>
      <div class="row" v-if="isActive">
        <div class="column checkbox">
          <input type="checkbox"
                 name="doNotHaveStreet"
                 id="doNotHaveStreet"
                 v-model="user.address.doNotHaveStreet"
                 @change="setValue('doNotHaveStreet')"

          >
          <label for="doNotHaveStreet" ref="doNotHaveStreet"> <span></span>Я подтверждаю, что по моему адресу регистрации улица отсутствует.</label>
        </div>
      </div>
    </div>
	</div>
</template>

<script>
  import UserGetter from '@/mixins/User/UserGetterMixin'
  import UserSetter from '@/mixins/User/UserSetterMixin'
  import UserErrorText from '@/mixins/User/UserErrorTextMixin'
  import IndicatorRegistration from '@/mixins/IndicatorRegistration'
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  import { REQUIRED_FIELD, MIN_LENGHT, MAX_LENGHT } from '@/components/Validators/CustomVeeValidateMessage'
  import {suggestAddress} from '@/utils/api'

  export default {
    name: 'test-reg',
    mixins: [
      UserGetter,
      UserSetter,
      UserErrorText,
      IndicatorRegistration,
      GetValidateClass
    ],
    data () {
      return {
        errorColor: {
          color: 'red'
        },
        notActive: false,
        isOpenRegion: false,
        isOpenHouse: false,
        isActive: false,
        selectedItem: 0,
        //
        region_with_type: '',
        city_type: '',
        area_with_type: '',
        settlement_with_type: '',
        street_type: '',
        //
        city: '',
        settlement: '',
        region: '',
        street: '',
        house: '',
        index: '',
        housing: '',
        building: '',
        suggestions: [],
        houses: [],
        currentData: null,
        flat: '',
        //
        value: null,
        region_fias_id: null,
        area_fias_id: null,
        city_fias_id: null,
        settlement_fias_id: null,
        street_fias_id: null,
        house_fias_id: null
      }
    },
    created () {
      this.region = (this.$store.getters.getUser.address.region_with_type && this.$store.getters.getUser.address.city !== 'Санкт-Петербург' && this.$store.getters.getUser.address.city !== 'Москва' ? this.$store.getters.getUser.address.region_with_type + ', ' : '') + // Название области
        (this.$store.getters.getUser.address.city_type ? this.$store.getters.getUser.address.city_type + '. ' : '') + // тип (город, деревня, село)
        (this.$store.getters.getUser.address.city ? this.$store.getters.getUser.address.city : '') + // название города
        (this.$store.getters.getUser.address.area_with_type ? ' ' + this.$store.getters.getUser.address.area_with_type : '') + // район, если такой есть
        (this.$store.getters.getUser.address.settlement_with_type ? ', ' + this.$store.getters.getUser.address.settlement_with_type : '') + // район, если такой есть
        (this.$store.getters.getUser.address.street_type ? ', ' + this.$store.getters.getUser.address.street_type + '. ' : '') + // тип (улица, б-р, п-к)
        (this.$store.getters.getUser.address.street ? this.$store.getters.getUser.address.street : '') // название улицы
      this.house = this.user.address.house
      this.index = this.user.address.postalCode
      this.housing = this.user.address.housing
      this.building = this.user.address.building
      this.flat = this.user.address.flat

      this.value = this.user.addressFiases.value
      this.region_fias_id = this.user.addressFiases.region_fias_id
      this.area_fias_id = this.user.addressFiases.area_fias_id
      this.city_fias_id = this.user.addressFiases.city_fias_id
      this.settlement_fias_id = this.user.addressFiases.settlement_fias_id
      this.street_fias_id = this.user.addressFiases.street_fias_id
      this.house_fias_id = this.user.addressFiases.house_fias_id
    },
    methods: {
      getRegion () {
        this.isOpenRegion = true
        suggestAddress(this.region)
          .then((res) => {
            this.suggestions = res.data.suggestions
          })
          .catch((err) => {
            console.log('err', err)
          })
        // this.params.getAddressRegistration = false
      },
      checkRegion (i) {
        // заполнение поля район, населенный пункт, улица
        this.region =
          (this.suggestions[i].data.region_with_type && this.suggestions[i].data.region !== 'Санкт-Петербург' && this.suggestions[i].data.region !== 'Москва' ? this.suggestions[i].data.region_with_type + ', ' : '') + // Название области
          (this.suggestions[i].data.city_type ? this.suggestions[i].data.city_type + '. ' : '') + // тип (город, деревня, село)
          (this.suggestions[i].data.city ? this.suggestions[i].data.city : '') + // название города
          (this.suggestions[i].data.area_with_type ? ' ' + this.suggestions[i].data.area_with_type : '') + // район, если такой есть
          (this.suggestions[i].data.settlement_with_type ? ', ' + this.suggestions[i].data.settlement_with_type : '') + // район, если такой есть
          (this.suggestions[i].data.street_type ? ', ' + this.suggestions[i].data.street_type + '. ' : '') + // тип (улица, б-р, п-к)
          (this.suggestions[i].data.street ? this.suggestions[i].data.street : '') // название улицы
        this.city = this.suggestions[i].data.city
        this.settlement = this.suggestions[i].data.settlement
        this.street = this.suggestions[i].data.street
        this.region_with_type = this.suggestions[i].data.region_with_type
        this.city_type = this.suggestions[i].data.city_type
        this.area_with_type = this.suggestions[i].data.area_with_type
        this.settlement_with_type = this.suggestions[i].data.settlement_with_type
        this.street_type = this.suggestions[i].data.street_type
        // автоматическое заполнение остальных полей
        this.house = (this.suggestions[i].data.house ? this.suggestions[i].data.house : '') // выведит в поле дом номер дома
        this.index = (this.suggestions[i].data.postal_code ? this.suggestions[i].data.postal_code : '') // выведит в поле индекс
        // заполнение полей корпус и строение
        if (this.suggestions[i].data.block_type === 'к') {
          const buildingIndex = this.suggestions[i].data.block.indexOf(' стр ')
          if (buildingIndex > -1) {
            this.housing = (this.suggestions[i].data.block ? this.suggestions[i].data.block.substring(0, buildingIndex) : '')
            this.building = (this.suggestions[i].data.block ? this.suggestions[i].data.block.substring(buildingIndex + 5) : '')
          } else {
            this.housing = (this.suggestions[i].data.block ? this.suggestions[i].data.block : '')
          }
        } else if (this.suggestions[i].data.block_type === 'стр' || this.suggestions[i].data.block_type === 'сооружение') {
          this.building = (this.suggestions[i].data.block ? this.suggestions[i].data.block : '')
        }
        if (this.suggestions[i].data.block_type === null) {
          this.housing = ''
          this.building = ''
        }
        this.currentData = {...this.currentData, ...this.suggestions[this.selectedItem]}
      },
      getHouse () {
        this.isOpenHouse = true
        suggestAddress(this.region + ', д' + this.house)
          .then((res) => {
            console.log(res.data.suggestions)
            this.suggestions = res.data.suggestions
            this.houses = res.data.suggestions.reduce((acc, item) => {
              if (!item.data.house) {
                return acc
              }
              console.log(item.data)
              console.log(this.street)
              return [...acc, `${!this.street ? item.data.street || '' : ''} ${item.data.house_type || ''} ${item.data.house || ''} ${item.data.block_type || ''} ${item.data.block || ''}`]
            }, [])
          })
          .catch((err) => {
            console.log('err:', err)
          })
      },
      checkHouse (i) {
        this.house = this.suggestions[i].data.house
        this.index = (this.suggestions[i].data.postal_code ? this.suggestions[i].data.postal_code : '') // выведит в поле индекс
        if (this.suggestions[i].data.block_type === 'к') {
          const buildingIndex = this.suggestions[i].data.block.indexOf(' стр ')
          if (buildingIndex > -1) {
            this.housing = (this.suggestions[i].data.block ? this.suggestions[i].data.block.substring(0, buildingIndex) : '')
            this.building = (this.suggestions[i].data.block ? this.suggestions[i].data.block.substring(buildingIndex + 5) : '')
          } else {
            this.housing = (this.suggestions[i].data.block ? this.suggestions[i].data.block : '')
          }
        } else if (this.suggestions[i].data.block_type === 'стр' || this.suggestions[i].data.block_type === 'сооружение') {
          this.building = (this.suggestions[i].data.block ? this.suggestions[i].data.block : '')
        }
        if (this.suggestions[i].data.block_type === null) {
          this.housing = ''
          this.building = ''
        }
        this.currentData = {...this.currentData, ...this.suggestions[this.selectedItem]}
        this.updateUser(this.user)
      },
      moveDownRegion () {
        if (!this.isOpenRegion && !this.isOpenHouse) {
          return false
        }
        this.selectedItem = (this.selectedItem + 1) % this.suggestions.length
        this.region = this.suggestions.length > 1 ? (this.suggestions[this.selectedItem].value) : null
      },
      moveUpRegion () {
        if (!this.isOpenRegion && !this.isOpenHouse) {
          return
        }
        this.selectedItem = this.selectedItem - 1 < 0 ? this.suggestions.length - 1 : this.selectedItem - 1
        this.region = this.suggestions.length > 1 ? (this.suggestions[this.selectedItem].value) : null
      },
      moveDownHouse () {
        if (!this.isOpenRegion && !this.isOpenHouse) {
          return
        }
        this.selectedItem = (this.selectedItem + 1) % this.suggestions.length
        this.house = this.suggestions.length > 1 && this.suggestions[this.selectedItem].data.house !== undefined ? (this.suggestions[this.selectedItem].data.house) : null
      },
      moveUpHouse () {
        if (!this.isOpenRegion && !this.isOpenHouse) {
          return
        }
        this.selectedItem = this.selectedItem - 1 < 0 ? this.suggestions.length - 1 : this.selectedItem - 1
        this.house = this.suggestions.length > 1 ? (this.suggestions[this.selectedItem].data.house) : null
      },
      checkStreet () {
        this.isOpenRegion = false
        if (this.street === '' || this.street === null) {
          this.isActive = true
        } else {
          this.isActive = false
          this.user.address.doNotHaveStreet = false
          this.updateUser(this.user)
        }
      },
      fixHouse (e) {
        this.isOpenHouse = false
        this.user.address.house = e.target.value
        this.updateUser(this.user)
      },
      changeIndex (e) {
        this.user.address.postalCode = e.target.value
        this.updateUser(this.user)
      },
      changeHousing (e) {
        e.target.value === '' ? this.user.address.housing = null : this.user.address.housing = e.target.value
        this.updateUser(this.user)
      },
      changeBuilding (e) {
        e.target.value === '' ? this.user.address.building = null : this.user.address.building = e.target.value
        this.updateUser(this.user)
      },
      changeFlat (e) {
        e.target.value === '' ? this.user.address.flat = null : this.user.address.flat = e.target.value
        this.updateUser(this.user)
      }
    },
    watch: {
      '$store.getters.getUser.addressFiases.value' (val) {
        this.region = (this.currentData.data.region_with_type && this.currentData.data.region !== 'Санкт-Петербург' && this.currentData.data.region !== 'Москва' ? this.currentData.data.region_with_type + ', ' : '') + // Название области
        (this.currentData.data.city_type ? this.currentData.data.city_type + '. ' : '') + // тип (город, деревня, село)
        (this.currentData.data.city ? this.currentData.data.city : '') + // название города
        (this.currentData.data.area_with_type ? ' ' + this.currentData.data.area_with_type : '') + // район, если такой есть
        (this.currentData.data.settlement_with_type ? ', ' + this.currentData.data.settlement_with_type : '') + // район, если такой есть
        (this.currentData.data.street_type ? ', ' + this.currentData.data.street_type + '. ' : '') + // тип (улица, б-р, п-к)
        (this.currentData.data.street ? this.currentData.data.street : '') // название улицы
        this.isActive = !this.street
      },
      currentData () {
        try {
          let address = this.user.address
          let info = this.currentData.data
          address.region_with_type = info.region_with_type
          address.city_type = info.city_type
          address.area_with_type = info.area_with_type
          address.settlement_with_type = info.settlement_with_type
          address.street_type = info.street_type
          address.postalCode = info.postal_code
          address.region = info.region_kladr_id
          address.city = (info.city === null) ? info.settlement : info.city
          address.settlement = info.settlement
          address.street = info.street
          address.geoLat = info.geo_lat
          address.geoLon = info.geo_lon
          address.house = info.house
          if (this.currentData.data.block_type === 'к') {
            const buildingIndex = this.currentData.data.block.indexOf(' стр ')
            if (buildingIndex > -1) {
              address.housing = this.currentData.data.block.substring(0, buildingIndex)
              address.building = this.currentData.data.block.substring(buildingIndex + 5)
            } else {
              address.housing = this.currentData.data.block
            }
          } else if (this.currentData.data.block_type === 'стр' || this.currentData.data.block_type === 'сооружение') {
            address.building = this.currentData.data.block
          }
          let addressFiases = this.user.addressFiases
          addressFiases.value = this.currentData.value
          addressFiases.region_fias_id = info.region_fias_id
          addressFiases.area_fias_id = info.area_fias_id
          addressFiases.city_fias_id = info.city_fias_id
          addressFiases.settlement_fias_id = info.settlement_fias_id
          addressFiases.street_fias_id = info.street_fias_id
          addressFiases.house_fias_id = info.house_fias_id
          this.updateUser(this.user)
        } catch (e) {
          return false
        }
      }
    },
    mounted () {
      this.$validator.localize(REQUIRED_FIELD)
      this.$validator.localize(MIN_LENGHT)
      this.$validator.localize(MAX_LENGHT)
    },
    updated () {
      this.$store.state.user.validatedForms.step2.registrationAddress = Object.keys(this.$validator.flags).reduce((acc, item) => acc && this.$validator.flags[item].valid, true)
    }
  }
</script>

<style scoped>
  .options-list {
    display: flex;
    flex-direction: column;
    margin-top: -40px;
    border: 1px solid #dbdbdb;
    border-radius: 0 0 3px 3px;
    position: relative;
    width: 100%;
    overflow: hidden;
    list-style: none;
    z-index: 6;
  }
  .options-list li {
    width: 100%;
    flex-wrap: wrap;
    background: white;
    margin: 0;
    border-bottom: 1px solid #eee;
    color: #363636;
    padding: 7px;
    cursor: pointer;
  }
  li.highlighted {
    background: #f8f8f8;
  }
  .without-marker li {
    border-bottom: none;
    background: none;
  }
</style>
